diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/three-gpp-channel-model.cc ns-3.38/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.37/src/spectrum/model/three-gpp-channel-model.cc	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/three-gpp-channel-model.cc	2023-03-16 20:54:23.828869000 -0700
@@ -2187,7 +2229,7 @@
     }
 
     // generate or update non-self blocking
-    if (channelParams->m_nonSelfBlocking.size() == 0) // generate new blocking regions
+    if (channelParams->m_nonSelfBlocking.empty()) // generate new blocking regions
     {
         for (uint16_t blockInd = 0; blockInd < m_numNonSelfBlocking; blockInd++)
         {
@@ -2288,14 +2330,14 @@
                       "the ZOA should be the range of [0,180]");
 
         // check self blocking
-        NS_LOG_INFO("AOA=" << clusterAOA[cInd] << " Block Region[" << phiSb - xSb / 2 << ","
-                           << phiSb + xSb / 2 << "]");
-        NS_LOG_INFO("ZOA=" << clusterZOA[cInd] << " Block Region[" << thetaSb - ySb / 2 << ","
-                           << thetaSb + ySb / 2 << "]");
-        if (std::abs(clusterAOA[cInd] - phiSb) < (xSb / 2) &&
-            std::abs(clusterZOA[cInd] - thetaSb) < (ySb / 2))
+        NS_LOG_INFO("AOA=" << clusterAOA[cInd] << " Block Region[" << phiSb - xSb / 2.0 << ","
+                           << phiSb + xSb / 2.0 << "]");
+        NS_LOG_INFO("ZOA=" << clusterZOA[cInd] << " Block Region[" << thetaSb - ySb / 2.0 << ","
+                           << thetaSb + ySb / 2.0 << "]");
+        if (std::abs(clusterAOA[cInd] - phiSb) < (xSb / 2.0) &&
+            std::abs(clusterZOA[cInd] - thetaSb) < (ySb / 2.0))
         {
-            powerAttenuation[cInd] += 30; // anttenuate by 30 dB.
+            powerAttenuation[cInd] += 30; // attenuate by 30 dB.
             NS_LOG_INFO("Cluster[" << +cInd
                                    << "] is blocked by self blocking region and reduce 30 dB power,"
                                       "the attenuation is ["
@@ -2331,17 +2373,17 @@
             if (std::abs(clusterAOA[cInd] - phiK) < (xK) &&
                 std::abs(clusterZOA[cInd] - thetaK) < (yK))
             {
-                double A1 = clusterAOA[cInd] - (phiK + xK / 2);   //(7.6-24)
-                double A2 = clusterAOA[cInd] - (phiK - xK / 2);   //(7.6-25)
-                double Z1 = clusterZOA[cInd] - (thetaK + yK / 2); //(7.6-26)
-                double Z2 = clusterZOA[cInd] - (thetaK - yK / 2); //(7.6-27)
+                double A1 = clusterAOA[cInd] - (phiK + xK / 2.0);   //(7.6-24)
+                double A2 = clusterAOA[cInd] - (phiK - xK / 2.0);   //(7.6-25)
+                double Z1 = clusterZOA[cInd] - (thetaK + yK / 2.0); //(7.6-26)
+                double Z2 = clusterZOA[cInd] - (thetaK - yK / 2.0); //(7.6-27)
                 int signA1;
                 int signA2;
                 int signZ1;
                 int signZ2;
                 // draw sign for the above parameters according to table 7.6.4.1-3 Description of
                 // signs
-                if (xK / 2 < clusterAOA[cInd] - phiK && clusterAOA[cInd] - phiK <= xK)
+                if (xK / 2.0 < clusterAOA[cInd] - phiK && clusterAOA[cInd] - phiK <= xK)
                 {
                     signA1 = -1;
                 }
@@ -2349,7 +2391,7 @@
                 {
                     signA1 = 1;
                 }
-                if (-1 * xK < clusterAOA[cInd] - phiK && clusterAOA[cInd] - phiK <= -1 * xK / 2)
+                if (-1 * xK < clusterAOA[cInd] - phiK && clusterAOA[cInd] - phiK <= -1 * xK / 2.0)
                 {
                     signA2 = -1;
                 }
@@ -2358,7 +2400,7 @@
                     signA2 = 1;
                 }
 
-                if (yK / 2 < clusterZOA[cInd] - thetaK && clusterZOA[cInd] - thetaK <= yK)
+                if (yK / 2.0 < clusterZOA[cInd] - thetaK && clusterZOA[cInd] - thetaK <= yK)
                 {
                     signZ1 = -1;
                 }
@@ -2366,7 +2408,8 @@
                 {
                     signZ1 = 1;
                 }
-                if (-1 * yK < clusterZOA[cInd] - thetaK && clusterZOA[cInd] - thetaK <= -1 * yK / 2)
+                if (-1 * yK < clusterZOA[cInd] - thetaK &&
+                    clusterZOA[cInd] - thetaK <= -1 * yK / 2.0)
                 {
                     signZ2 = -1;
                 }
@@ -2376,24 +2419,24 @@
                 }
                 double lambda = 3e8 / m_frequency;
                 double fA1 =
-                    atan(signA1 * M_PI / 2 *
+                    atan(signA1 * M_PI / 2.0 *
                          sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1 / cos(DegreesToRadians(A1)) - 1))) /
+                              (1.0 / cos(DegreesToRadians(A1)) - 1))) /
                     M_PI; //(7.6-23)
                 double fA2 =
-                    atan(signA2 * M_PI / 2 *
+                    atan(signA2 * M_PI / 2.0 *
                          sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1 / cos(DegreesToRadians(A2)) - 1))) /
+                              (1.0 / cos(DegreesToRadians(A2)) - 1))) /
                     M_PI;
                 double fZ1 =
-                    atan(signZ1 * M_PI / 2 *
+                    atan(signZ1 * M_PI / 2.0 *
                          sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1 / cos(DegreesToRadians(Z1)) - 1))) /
+                              (1.0 / cos(DegreesToRadians(Z1)) - 1))) /
                     M_PI;
                 double fZ2 =
-                    atan(signZ2 * M_PI / 2 *
+                    atan(signZ2 * M_PI / 2.0 *
                          sqrt(M_PI / lambda * channelParams->m_nonSelfBlocking[blockInd][R_INDEX] *
-                              (1 / cos(DegreesToRadians(Z2)) - 1))) /
+                              (1.0 / cos(DegreesToRadians(Z2)) - 1))) /
                     M_PI;
                 double lDb = -20 * log10(1 - (fA1 + fA2) * (fZ1 + fZ2)); //(7.6-22)
                 powerAttenuation[cInd] += lDb;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/three-gpp-channel-model.h ns-3.38/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.37/src/spectrum/model/three-gpp-channel-model.h	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/three-gpp-channel-model.h	2023-03-16 20:54:23.828869000 -0700
@@ -25,9 +25,6 @@
 #include <ns3/boolean.h>
 #include <ns3/channel-condition-model.h>
 #include <ns3/matrix-based-channel-model.h>
-#include <ns3/nstime.h>
-#include <ns3/object.h>
-#include <ns3/random-variable-stream.h>
 
 #include <complex.h>
 #include <unordered_map>
@@ -260,7 +257,7 @@
 
     /**
      * Prepare 3gpp channel parameters among the nodes a and b.
-     * The function does the followin steps described in 3GPP 38.901:
+     * The function does the following steps described in 3GPP 38.901:
      *
      * Step 4: Generate large scale parameters. All LSPS are uncorrelated.
      * Step 5: Generate Delays.
@@ -364,7 +361,7 @@
     // parameters for the blockage model
     bool m_blockage;               //!< enables the blockage model A
     uint16_t m_numNonSelfBlocking; //!< number of non-self-blocking regions
-    bool m_portraitMode;           //!< true if potrait mode, false if landscape
+    bool m_portraitMode;           //!< true if portrait mode, false if landscape
     double m_blockerSpeed;         //!< the blocker speed
 
     static const uint8_t PHI_INDEX = 0; //!< index of the PHI value in the m_nonSelfBlocking array
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.38/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.37/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2023-03-16 20:54:23.828869000 -0700
@@ -119,37 +119,19 @@
 {
     NS_LOG_FUNCTION(this);
 
-    uint16_t sAntenna = static_cast<uint16_t>(sW.size());
-    uint16_t uAntenna = static_cast<uint16_t>(uW.size());
+    size_t uAntennaNum = uW.GetSize();
+    size_t sAntennaNum = sW.GetSize();
 
-    NS_ASSERT(uAntenna == params->m_channel.size());
-    NS_ASSERT(sAntenna == params->m_channel.at(0).size());
+    NS_ASSERT(uAntennaNum == params->m_channel.GetNumRows());
+    NS_ASSERT(sAntennaNum == params->m_channel.GetNumCols());
 
-    NS_LOG_DEBUG("CalcLongTerm with sAntenna " << sAntenna << " uAntenna " << uAntenna);
+    NS_LOG_DEBUG("CalcLongTerm with " << uAntennaNum << " u antenna elements and " << sAntennaNum
+                                      << " s antenna elements.");
     // store the long term part to reduce computation load
     // only the small scale fading needs to be updated if the large scale parameters and antenna
-    // weights remain unchanged.
-    PhasedArrayModel::ComplexVector longTerm;
-    uint8_t numCluster = static_cast<uint8_t>(params->m_channel[0][0].size());
-
-    NS_ASSERT(uAntenna == params->m_channel.size());
-    NS_ASSERT(sAntenna == params->m_channel.at(0).size());
-
-    for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
-    {
-        std::complex<double> txSum(0, 0);
-        for (uint16_t sIndex = 0; sIndex < sAntenna; sIndex++)
-        {
-            std::complex<double> rxSum(0, 0);
-            for (uint16_t uIndex = 0; uIndex < uAntenna; uIndex++)
-            {
-                rxSum = rxSum + uW[uIndex] * params->m_channel[uIndex][sIndex][cIndex];
-            }
-            txSum = txSum + sW[sIndex] * rxSum;
-        }
-        longTerm.push_back(txSum);
-    }
-    return longTerm;
+    // weights remain unchanged. here we calculate long term uW * Husn * sW, the result is an array
+    // of values per cluster
+    return params->m_channel.MultiplyByLeftAndRightMatrix(uW.Transpose(), sW);
 }
 
 Ptr<SpectrumValue>
@@ -165,15 +147,15 @@
 
     Ptr<SpectrumValue> tempPsd = Copy<SpectrumValue>(txPsd);
 
-    // channel[rx][tx][cluster]
-    uint8_t numCluster = static_cast<uint8_t>(channelMatrix->m_channel[0][0].size());
+    // channel[cluster][rx][tx]
+    uint16_t numCluster = channelMatrix->m_channel.GetNumPages();
 
     // compute the doppler term
     // NOTE the update of Doppler is simplified by only taking the center angle of
     // each cluster in to consideration.
     double slotTime = Simulator::Now().GetSeconds();
     double factor = 2 * M_PI * slotTime * GetFrequency() / 3e8;
-    PhasedArrayModel::ComplexVector doppler;
+    PhasedArrayModel::ComplexVector doppler(numCluster);
 
     // The following asserts might seem paranoic, but it is important to
     // make sure that all the structures that are passed to this function
@@ -186,7 +168,7 @@
     NS_ASSERT(numCluster <= channelParams->m_angle[MatrixBasedChannelModel::ZOD_INDEX].size());
     NS_ASSERT(numCluster <= channelParams->m_angle[MatrixBasedChannelModel::AOA_INDEX].size());
     NS_ASSERT(numCluster <= channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX].size());
-    NS_ASSERT(numCluster <= longTerm.size());
+    NS_ASSERT(numCluster <= longTerm.GetSize());
 
     // check if channelParams structure is generated in direction s-to-u or u-to-s
     bool isSameDirection = (channelParams->m_nodeIds == channelMatrix->m_nodeIds);
@@ -197,9 +179,9 @@
     MatrixBasedChannelModel::DoubleVector aod;
 
     // if channel params is generated in the same direction in which we
-    // generate the channel matrix, angles and zenit od departure and arrival are ok,
+    // generate the channel matrix, angles and zenith od departure and arrival are ok,
     // just set them to corresponding variable that will be used for the generation
-    // of channel matrix, otherwise we need to flip angles and zenits of departure and arrival
+    // of channel matrix, otherwise we need to flip angles and zeniths of departure and arrival
     if (isSameDirection)
     {
         zoa = channelParams->m_angle[MatrixBasedChannelModel::ZOA_INDEX];
@@ -215,11 +197,11 @@
         aoa = channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX];
     }
 
-    for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
+    for (uint16_t cIndex = 0; cIndex < numCluster; cIndex++)
     {
         // Compute alpha and D as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
         // These terms account for an additional Doppler contribution due to the
-        // presence of moving objects in the sorrounding environment, such as in
+        // presence of moving objects in the surrounding environment, such as in
         // vehicular scenarios.
         // This contribution is applied only to the delayed (reflected) paths and
         // must be properly configured by setting the value of
@@ -240,10 +222,10 @@
                        sin(zod[cIndex] * M_PI / 180) * sin(aod[cIndex] * M_PI / 180) * sSpeed.y +
                        cos(zod[cIndex] * M_PI / 180) * sSpeed.z) +
                       2 * alpha * D);
-        doppler.emplace_back(cos(tempDoppler), sin(tempDoppler));
+        doppler[cIndex] = std::complex<double>(cos(tempDoppler), sin(tempDoppler));
     }
 
-    NS_ASSERT(numCluster <= doppler.size());
+    NS_ASSERT(numCluster <= doppler.GetSize());
 
     // apply the doppler term and the propagation delay to the long term component
     // to obtain the beamforming gain
@@ -255,7 +237,7 @@
         {
             std::complex<double> subsbandGain(0.0, 0.0);
             double fsb = (*sbit).fc; // center frequency of the sub-band
-            for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
+            for (uint16_t cIndex = 0; cIndex < numCluster; cIndex++)
             {
                 double delay = -2 * M_PI * fsb * (channelParams->m_delay[cIndex]);
                 subsbandGain = subsbandGain + longTerm[cIndex] * doppler[cIndex] *
@@ -279,7 +261,7 @@
         longTerm; // vector containing the long term component for each cluster
 
     // check if the channel matrix was generated considering a as the s-node and
-    // b as the u-node or viceversa
+    // b as the u-node or vice-versa
     PhasedArrayModel::ComplexVector sW;
     PhasedArrayModel::ComplexVector uW;
     if (!channelMatrix->IsReverse(aPhasedArrayModel->GetId(), bPhasedArrayModel->GetId()))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/tv-spectrum-transmitter.h ns-3.38/src/spectrum/model/tv-spectrum-transmitter.h
--- ns-3.37/src/spectrum/model/tv-spectrum-transmitter.h	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/tv-spectrum-transmitter.h	2023-03-16 20:54:23.828869000 -0700
@@ -129,7 +129,7 @@
     /** Sets up signal to be transmitted */
     virtual void SetupTx();
 
-    enum TvType m_tvType;      //!< Type of TV transmitter
+    TvType m_tvType;           //!< Type of TV transmitter
     double m_startFrequency;   //!< Start frequency (in Hz) of TV transmitter's signal
     double m_channelBandwidth; //!< Bandwidth (in Hz) of TV transmitter's signal
     double m_basePsd; //!< Base power spectral density value (in dBm/Hz) of TV transmitter's signal
